<?
# Passed in: $album, $pic, $user, $height, $width, $dispsize

include("common.inc");
$pic = stripslashes($pic);


function CreateImage($new_width, $new_height,$source,$dest, $dispsize=100) {
	$sourcedate = 0;
	$destdate = 0;
	global $convert;
	global $album;
	global $cache_base;
        global $username;
	global $ImageTool;

	if (file_exists($dest)) {
		clearstatcache();
		$sourceinfo = stat($source);
		$destinfo = stat($dest);
		$sourcedate = $sourceinfo[10];
		$destdate = $destinfo[10];
	}
	if (!file_exists("$dest") or ($sourcedate > $destdate)) {
		$imgsize = GetImageSize($source);
		$width = $imgsize[0];
		$height = $imgsize[1];

		if ($width == 0) {
			# Can't really scale a zero-width image...
			# XXX: have this display an icon for the file type
			return -1;
		}

                if (($new_width == 0) || ($new_height == 0)) {
                  if ($width > $height) {
                    $new_width = $dispsize;
                    $new_height = ceil($dispsize * $height / $width);
                  } else {
                    $new_height = $dispsize;
                    $new_width = ceil($dispsize * $width / $height);
                  }
                }

		if ($ImageTool == "int") {
			if (preg_match("/\.jp(g|eg)$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromJPEG($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} elseif (preg_match("/\.gif$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromGIF($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} elseif (preg_match("/\.png$/i",$source)) {
				# disable errors in case of invalid image
				$error = error_reporting(0);
				$im = ImageCreateFromPNG($source);
				error_reporting($error);
				if (!$im) {
					# problem reading the file
					return -1;
				}
				$new_im = ImageCreate($new_width,$new_height);
	
				ImageCopyResized($new_im,$im,0,0,0,0,$new_width,$new_height,ImageSX($im),ImageSY($im));

				# Check if the directories are there
				checkdir("$cache_base/$username/$album");
			
				ImageJPEG($new_im,$dest,75);
			} else {
				return -1;
			}
		} elseif ($ImageTool == "ext") {
			if ($username != '') {
				$newalbum = $username."/".$album;
			} else {
				$newalbum = $album;
			}
			system("$convert $new_width $new_height \"$cache_base\" \"$newalbum\" \"$source\" \"$dest\" 2>&1");
		}

		if (!file_exists($dest)) {
			return -1;
		}
	}
}

if ($album == "##NONE##") {
  $file = "$scriptbase/$pic";
} else {
  $file = "$realpixbase$album/$pic";
}


if (($dispsize != "Original") && ($album != "##NONE##")) {
  $destpic = "${pic}__scaled_${dispsize}.jpg";
  $destfile = $cache_base."/".$usercachebase.$album."/".$destpic;

  $ret = CreateImage($width, $height, $file, $destfile, $dispsize);
  if ($ret == -1) {
    $file = $scriptbase.$unknown_url;
  } else {
    $file = $scriptbase.$destfile;
  }
}

if (preg_match("/\.jp(g|eg)$/i",$file)) {
  $type = "jpeg";
} elseif (preg_match("/\.gif$/i",$file)) {
  $type = "gif";
} elseif (preg_match("/\.png$/i",$file)) {
  $type = "png";
}

Header("Content-type: image/$type");


readfile($file);
//$fn=fopen($file, "r");
//fpassthru($fn);
//fclose($fn);
?>
